

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.25. load &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.26. lock_acquire" href="lock_acquire.html" />
    <link rel="prev" title="7.3.24. io_flush" href="io_flush.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/load.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="lock_acquire.html" title="7.3.26. lock_acquire"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="io_flush.html" title="7.3.24. io_flush"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.25. </span><code class="docutils literal notranslate"><span class="pre">load</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="load">
<h1><span class="section-number">7.3.25. </span><code class="docutils literal notranslate"><span class="pre">load</span></code><a class="headerlink" href="#load" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.25.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">load</span></code> loads data as records in the current database and updates values of each columns.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.25.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>The required parameters are only <code class="docutils literal notranslate"><span class="pre">values</span></code> and <code class="docutils literal notranslate"><span class="pre">table</span></code>. Other
parameters are optional:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load values
     table
     [columns=null]
     [ifexists=null]
     [input_type=json]
     [each=null]
     [output_ids=no]
     [output_errors=no]
     [lock_table=no]
</pre></div>
</div>
<p>This command is a special command. Other commands need to pass all
parameters to one line but this command can accept <code class="docutils literal notranslate"><span class="pre">values</span></code> as
followed data.</p>
<p>If you use command line style, you can pass <code class="docutils literal notranslate"><span class="pre">values</span></code> like the
following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Bookmarks
[
{&quot;_key&quot;: &quot;http://groonga.org/&quot;, &quot;title&quot;: &quot;Groonga&quot;},
{&quot;_key&quot;: &quot;http://mroonga.org/&quot;, &quot;title&quot;: &quot;Mroonga&quot;}
]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">[...]</span></code> is value of <code class="docutils literal notranslate"><span class="pre">values</span></code>.</p>
<p>If you use HTTP style, you can pass <code class="docutils literal notranslate"><span class="pre">values</span></code> as body:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% curl \
    --request POST \
    --header &quot;Content-Type: application/json&quot; \
    --data-raw &#39;[{&quot;_key&quot;: &quot;http://groonga.org/&quot;}]&#39; \
    http://localhost:10041/d/load?table=Bookmarks&quot;
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.25.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is a schema definition to show usage:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Entries TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Entries content COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Here is an example to add records to <code class="docutils literal notranslate"><span class="pre">Entries</span></code> table by parameter:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load \
  --table Entries \
  --values &quot;[{\&quot;_key\&quot;:\&quot;Groonga\&quot;,\&quot;content\&quot;:\&quot;It&#39;s very fast!!\&quot;}]&quot;
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p>Here is an example to add records to <code class="docutils literal notranslate"><span class="pre">Entries</span></code> table from standard input:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Entries
[
{&quot;_key&quot;: &quot;Groonga&quot;, &quot;content&quot;: &quot;It&#39;s very fast!!&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p>Here is an example to lock table while updating columns:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Entries --lock_table yes
[
{&quot;_key&quot;: &quot;Groonga&quot;, &quot;content&quot;: &quot;It&#39;s very fast!!&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.25.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters. Parameters are categorized.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.25.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are some required parameters.</p>
<div class="section" id="values">
<span id="load-values"></span><h4><span class="section-number">7.3.25.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">values</span></code><a class="headerlink" href="#values" title="Permalink to this headline">¶</a></h4>
<p>Specifies values to be loaded.</p>
<p>Values should satisfy <code class="docutils literal notranslate"><span class="pre">input_type</span></code> format. If you specify <code class="docutils literal notranslate"><span class="pre">json</span></code>
as <code class="docutils literal notranslate"><span class="pre">input_type</span></code>, you can choose a format from below:</p>
<p>Bracket style:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[
[COLUMN_NAME1, COLUMN_NAME2, ...],
[VALUE1, VALUE2, ...],
[VALUE1, VALUE2, ...],
...
]
</pre></div>
</div>
<p>Brace style:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[
{&quot;COLUMN_NAME1&quot;: VALUE1, &quot;COLUMN_NAME2&quot;: VALUE2, ...},
{&quot;COLUMN_NAME1&quot;: VALUE1, &quot;COLUMN_NAME2&quot;: VALUE2, ...},
...
]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">[COLUMN_NAME1,</span> <span class="pre">COLUMN_NAME2,</span> <span class="pre">...]</span></code> in bracket style is effective
only when <a class="reference internal" href="#load-columns"><span class="std std-ref">columns</span></a> parameter isn’t specified.</p>
<p>When a target table contains primary key, you must specify <code class="docutils literal notranslate"><span class="pre">_key</span></code>
column (pseudo column associated primary key) as the one of
<code class="docutils literal notranslate"><span class="pre">COLUMN_NAME</span></code>.</p>
<p>If you specify <code class="docutils literal notranslate"><span class="pre">apache-arrow</span></code> as <code class="docutils literal notranslate"><span class="pre">input_type</span></code>, you must use
<a class="reference external" href="https://arrow.apache.org/docs/format/Columnar.html#ipc-streaming-format">Apache Arrow IPC Streaming Format</a>. You can’t use <a class="reference external" href="https://arrow.apache.org/docs/format/Columnar.html#ipc-file-format">Apache Arrow IPC
File Format</a>.</p>
<p>You must use HTTP interface to use Apache Arrow. You can’t use Apache
Arrow in command line interface.</p>
<p>You must set <code class="docutils literal notranslate"><span class="pre">application/x-apache-arrow-streaming</span></code> to
<code class="docutils literal notranslate"><span class="pre">Content-Type</span></code> HTTP request header.</p>
<p>You must choose suitable record batch size. Groonga loads data per
record batch. If you choose very large record batch size, Groonga
can’t start loading until whole data of a record batch are received.
If you choose very small record batch size, Groonga can load data
incrementally but overhead will be large. Suitable record batch size
depends on your system but 1024 or so will be suitable.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">values</span></code> isn’t specified any values, they are read from the
standard input in command line style or body in HTTP style.</p>
</div>
<div class="section" id="table">
<span id="load-table"></span><h4><span class="section-number">7.3.25.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">table</span></code><a class="headerlink" href="#table" title="Permalink to this headline">¶</a></h4>
<p>Specifies a table name you want to add records.</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.25.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are some optional parameters.</p>
<div class="section" id="columns">
<span id="load-columns"></span><h4><span class="section-number">7.3.25.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">columns</span></code><a class="headerlink" href="#columns" title="Permalink to this headline">¶</a></h4>
<p>Specifies column names in added records with comma separations.</p>
</div>
<div class="section" id="ifexists">
<span id="load-ifexists"></span><h4><span class="section-number">7.3.25.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">ifexists</span></code><a class="headerlink" href="#ifexists" title="Permalink to this headline">¶</a></h4>
<p>Specifies executed expression in
<a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">Script syntax</span></a> when the same primary key as
added records already exists in your table.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">ifexists</span></code> specifies expression and its value is <code class="docutils literal notranslate"><span class="pre">true</span></code>, values
in other (all columns excluding <code class="docutils literal notranslate"><span class="pre">_key</span></code> column) columns is updated.</p>
</div>
<div class="section" id="input-type">
<span id="load-input-type"></span><h4><span class="section-number">7.3.25.4.2.3. </span><code class="docutils literal notranslate"><span class="pre">input_type</span></code><a class="headerlink" href="#input-type" title="Permalink to this headline">¶</a></h4>
<p>Specifies an input format for <code class="docutils literal notranslate"><span class="pre">values</span></code>.</p>
<p>Note that you must also specify suitable HTTP <code class="docutils literal notranslate"><span class="pre">Content-Type</span></code> header
value when you use <code class="docutils literal notranslate"><span class="pre">input_type</span></code> with HTTP interface.</p>
<p>Here are available types and <code class="docutils literal notranslate"><span class="pre">Content-Type</span></code> values:</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Type</p></th>
<th class="head"><p><code class="docutils literal notranslate"><span class="pre">Content-Type</span></code></p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">json</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">application/json</span></code></p></td>
<td><p>Use JSON for <code class="docutils literal notranslate"><span class="pre">values</span></code> format.</p>
<p>This is the default.</p>
</td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">apache-arrow</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">application/x-apache-arrow-streaming</span></code></p></td>
<td><div class="versionadded">
<p><span class="versionmodified added">New in version 9.1.1.</span></p>
</div>
<p>Use Apache Arrow for <code class="docutils literal notranslate"><span class="pre">values</span></code> format.</p>
</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="each">
<span id="load-each"></span><h4><span class="section-number">7.3.25.4.2.4. </span><code class="docutils literal notranslate"><span class="pre">each</span></code><a class="headerlink" href="#each" title="Permalink to this headline">¶</a></h4>
<p>TODO</p>
</div>
<div class="section" id="output-ids">
<span id="load-output-ids"></span><h4><span class="section-number">7.3.25.4.2.5. </span><code class="docutils literal notranslate"><span class="pre">output_ids</span></code><a class="headerlink" href="#output-ids" title="Permalink to this headline">¶</a></h4>
<p>TODO</p>
</div>
<div class="section" id="output-errors">
<span id="load-output-errors"></span><h4><span class="section-number">7.3.25.4.2.6. </span><code class="docutils literal notranslate"><span class="pre">output_errors</span></code><a class="headerlink" href="#output-errors" title="Permalink to this headline">¶</a></h4>
<p>TODO</p>
</div>
<div class="section" id="lock-table">
<span id="load-lock-table"></span><h4><span class="section-number">7.3.25.4.2.7. </span><code class="docutils literal notranslate"><span class="pre">lock_table</span></code><a class="headerlink" href="#lock-table" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 8.0.6.</span></p>
</div>
<p>Specifies whether locking table while updating columns.</p>
<p>The default is <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
<p>If you may run destructive commands such as <code class="docutils literal notranslate"><span class="pre">load</span></code>, <code class="docutils literal notranslate"><span class="pre">delete</span></code> and
so on concurrently, it may break database. For example, if you’re
updating a record by <code class="docutils literal notranslate"><span class="pre">load</span></code> and deleting the updating record by
<code class="docutils literal notranslate"><span class="pre">delete</span></code>, the <code class="docutils literal notranslate"><span class="pre">load</span></code> may refer the delete record.</p>
<p>You can guard the update conflict by locking the target table but it
reduces load performance.</p>
<p>If you specify <code class="docutils literal notranslate"><span class="pre">yes</span></code> to this parameter, you can lock the target
table while updating columns. Here is the update sequence of each
record:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>Lock the target table</p></li>
<li><p>Add or refer a record to the target table</p></li>
<li><p>Unlock the target table</p></li>
<li><p>Lock the target table when <code class="docutils literal notranslate"><span class="pre">lock_table</span></code> is <code class="docutils literal notranslate"><span class="pre">yes</span></code></p></li>
<li><p>Update columns of the target record</p></li>
<li><p>Unlock the target table when <code class="docutils literal notranslate"><span class="pre">lock_table</span></code> is <code class="docutils literal notranslate"><span class="pre">yes</span></code></p></li>
</ol>
</div></blockquote>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.25.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>The command returns a response with the following format:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[THE_NUMBER_OF_LOADED_RECORDS]
</pre></div>
</div>
<p>The command returns a response with the following format with
<a class="reference internal" href="../command/command_version.html"><span class="doc">Command version</span></a> 3 or later:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>{
  &quot;n_loaded_records&quot;: THE_NUMBER_OF_LOADED_RECORDS,
  &quot;loaded_ids&quot;: [
    LOADED_RECORD&#39;S_ID1,
    LOADED_RECORD&#39;S_ID2,
    ...
  ],
  &quot;errors&quot;: [
    {
      &quot;return_code&quot;: RETURN_CODE_FOR_1ST_RECORD,
      &quot;message&quot;: MESSAGE_FOR_1ST_RECORD
    },
    {
      &quot;return_code&quot;: RETURN_CODE_FOR_2ND_RECORD,
      &quot;message&quot;: MESSAGE_FOR_2ND_RECORD
    },
    ...
  ]
}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">loaded_ids</span></code> is only included when <a class="reference internal" href="#load-output-ids"><span class="std std-ref">output_ids</span></a> is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
<p><code class="docutils literal notranslate"><span class="pre">errors</span></code> is only included when <a class="reference internal" href="#load-output-errors"><span class="std std-ref">output_errors</span></a> is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.3.25.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<blockquote>
<div><ul class="simple">
<li><p><a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">Script syntax</span></a></p></li>
</ul>
</div></blockquote>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.25. <code class="docutils literal notranslate"><span class="pre">load</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.25.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.25.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.25.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.25.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.25.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#values">7.3.25.4.1.1. <code class="docutils literal notranslate"><span class="pre">values</span></code></a></li>
<li><a class="reference internal" href="#table">7.3.25.4.1.2. <code class="docutils literal notranslate"><span class="pre">table</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.3.25.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#columns">7.3.25.4.2.1. <code class="docutils literal notranslate"><span class="pre">columns</span></code></a></li>
<li><a class="reference internal" href="#ifexists">7.3.25.4.2.2. <code class="docutils literal notranslate"><span class="pre">ifexists</span></code></a></li>
<li><a class="reference internal" href="#input-type">7.3.25.4.2.3. <code class="docutils literal notranslate"><span class="pre">input_type</span></code></a></li>
<li><a class="reference internal" href="#each">7.3.25.4.2.4. <code class="docutils literal notranslate"><span class="pre">each</span></code></a></li>
<li><a class="reference internal" href="#output-ids">7.3.25.4.2.5. <code class="docutils literal notranslate"><span class="pre">output_ids</span></code></a></li>
<li><a class="reference internal" href="#output-errors">7.3.25.4.2.6. <code class="docutils literal notranslate"><span class="pre">output_errors</span></code></a></li>
<li><a class="reference internal" href="#lock-table">7.3.25.4.2.7. <code class="docutils literal notranslate"><span class="pre">lock_table</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.25.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.3.25.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="io_flush.html"
                        title="previous chapter"><span class="section-number">7.3.24. </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="lock_acquire.html"
                        title="next chapter"><span class="section-number">7.3.26. </span><code class="docutils literal notranslate"><span class="pre">lock_acquire</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="lock_acquire.html" title="7.3.26. lock_acquire"
             >next</a> |</li>
        <li class="right" >
          <a href="io_flush.html" title="7.3.24. io_flush"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.25. </span><code class="docutils literal notranslate"><span class="pre">load</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>